#ifndef _CURTAIN_H
#define _CURTAIN_H

#include <string>
#include <queue>
#include <pthread.h>

#include "module.h"
#include "configs.h"
#include "deftypes.h"

class Curtain : public Module {
    static const unsigned int qlength = 4;
    static const SComm OPEN;
    static const SComm CLOSE;
    static const SComm STOP;
    static const SComm UNLOCK;
    static const SComm LOCK;
    static const SWord SET_LIM_TIME;
    static const SWord SET_LIM_INDEX;
    static const SWord SET_ACTIV_PAUSE;
    static const AData GET_POSITION;
    double freeze;
    double norm_rate;
    int sleep_time;
    int position_opened;
    int lim_motion_time;
    static pthread_t Watch_thread;
    point<int> curr_position;
private:
    static void* thread( void* );
    void lineWatchdog();
    point<int> getPosition();
    class Handler {
    public:
        static bool expired;
    private:
        static void catch_stop( int );
        static Curtain *curts;
    public:
        Handler( Curtain *th );
    };
public:
    Curtain( Config&, RS485&, const std::string& );
    ~Curtain();
    void close();
    void open(int);
    const std::string& devStatus();
    point<int> position() { return curr_position; }
    double avgPosition() { return 0.5*(curr_position.x()+curr_position.y()); }
//    int open_position() { return position_opened; } //    
    int uptime() { return lim_motion_time; }
    double rate() { return norm_rate; }
};

#endif
