#ifndef _DOME_DEVICE_H
#define _DOME_DEVICE_H

#include <memory>
#include <string>
#include <vector>
#include <pthread.h>

#include "module.h"
#include <configs.h>
#include "deftypes.h"
#include "curtain.h"
#include "power.h"

class Result;

class Device {
    Result* out;
    std::string device;
    RS485 rs485;
    std::auto_ptr<Curtain>  dome_controller;
    std::auto_ptr<Power>  power_control;
public:
    Device( Config&, bool );
    ~Device();
    const std::string& status() { return dome_controller->devStatus(); }
    point<int> position() { return dome_controller->position(); }
    void close();
    void open( int );
    int needed_time( int pos );
    void power_off();
    void power_on();
    void light_off();
    void light_on();
    const std::string& power_stat() { return power_control->devStatus(); }
    const std::string& light_stat() { return power_control->netStatus(); }
};

#endif
