#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <valarray>
#include <iostream>
#include <iomanip>
#include <vector>
#include <numeric>
#include <signal.h>

#include "dome.h"
#include "modes.h"


const double spar_time=3.0;

const std::string   sect_operation("Operations");
const std::string   subs_close("Close");
const std::string   subs_open("Open");

Mode::Mode( Config &cf, Device &cm ) {
    cfg = &cf;
    ddv = &cm;
//    std::cerr << "Mode ";
}

Close::Close( Config &cf, Device &cm ) : Mode( cf, cm ) {
    position  = cfg->inp<int>( sect_operation, subs_close, "ClosePosition");
}

void  Close::action() {
    ErrlogSingl::instance().write( "Beginning to be dome closed" );
    break_mode = false;
    ddv->close();
}

int  Close::life() {
    up_time = ddv->needed_time( position ) + spar_time;
    return (int)up_time;
}

Open::Open( Config &cf, Device &cm ) : Mode( cf, cm ) {
    position  = cfg->inp<int>( sect_operation, subs_open, "OpenPosition");
//    std::cerr << "Constructor Open" << std::endl;
}

void Open::action() {
    ErrlogSingl::instance().write( "Beginning to be dome unclosed" );
    break_mode = false;
    ddv->open(position);
}

int Open::life() {
    up_time = ddv->needed_time( position ) + spar_time;
    return (int)up_time;
}

