#ifndef _MODES_H
#define _MODES_H

//#include <sys/time.h>
#include "configs.h"

class Device;
class Result;

class Mode {
protected:
    Config *cfg;
    Device *ddv;
    bool   break_mode;
    double up_time;
    int  position;
public:
    Mode( Config&, Device& );
    virtual ~Mode() {} // std::cerr << " Mode" << std::endl; }
    virtual void action() = 0;
    virtual int  life() { return (int)up_time; }
    virtual void stop_request() { break_mode = true; }
    virtual void set(int pos){}
};

class Close : public Mode {
public:
    Close( Config&, Device& );
    virtual ~Close(){} // std::cerr << "Destructor Close :" ;}
    void  action();
    int  life();
};

class Open : public Mode {
public:
    Open( Config&, Device& );
    virtual ~Open(){} //  std::cerr << "Destructor Open :" ; }
    void action();
    int  life();
    void set( int pos ) { position = pos; }
    int pos_opened() { return position; }
};

#endif
