#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <cmath>

#include  <vector>
#include  <iostream>
#include  <iomanip>
#include <stdexcept>

#include "power.h"

const int TIME_UNITS = 1;
const int MASS_IS_OFF = 0x10;
const int CORE_IS_OFF = 0x20;
const int NETP_IS_OFF = 0x40;

const std::string   sect_device("Devices");

const SComm Power::MAIN_OFF = 0x85;
const SComm Power::MAIN_ON  = 0x84;

const SWord Power::SET_PAUSE_MAIN =0x3c;
const SWord Power::SET_DELAY_MAIN = 0x36;

const SComm Power::NETP_OFF = 0x81;
const SComm Power::NETP_ON  = 0x80;

const SWord Power::SET_PAUSE_NETP =0x3a;
const SWord Power::SET_DELAY_NETP = 0x32;

Power::Power( Config& cfg, RS485& r, const std::string& s ) : Module( cfg, r, s ) {
    delay_main_off  = cfg.inp<int>( sect_device, s, "DelayMainOff");
    delay_light_off = cfg.inp<int>( sect_device, s, "DelayLightOff");
    sendWordCommand( SET_DELAY_MAIN, delay_main_off*TIME_UNITS );
//    sendSimpleCommand( MAIN_OFF );
    sendWordCommand( SET_DELAY_NETP, delay_light_off*TIME_UNITS );
//    sendSimpleCommand( NETP_OFF );
//    std::cerr << "Constructor Power" << std::endl;
}

Power::~Power() {
//    std::cerr << "Destructor Power" << std::endl;
}

void Power::main_off() {
    sendSimpleCommand( MAIN_OFF );
}

void Power::main_on() {
    sendSimpleCommand( MAIN_ON );
}

void Power::netp_off() {
    sendSimpleCommand( NETP_OFF );
}

void Power::netp_on() {
    sendSimpleCommand( NETP_ON );
}

const std::string on = "ON";
const std::string off = "OFF";

const std::string& Power::devStatus() {
    return MASS_IS_OFF&getStatus()? off : on;
}

const std::string& Power::netStatus() {
    return NETP_IS_OFF&getStatus()? off : on;
}
